﻿package {
	import flash.display.MovieClip;
	import flash.ui.Keyboard;
	
	/**
	 * 自機クラス
	 */
	public class MyShip extends MovieClip{
		
		var keyMgr:KeyMgr;		//キー管理クラス
		var ground:MovieClip;	//地形MCへの参照
		var moveSpd:Number = 10;//移動速度
		
		var vx:Number;			//移動ベクトル
		var vy:Number;
		
		
		/**
		 * コンストラクタ
		 * @param	stageMC		ステージへの参照 (キー管理クラスに渡す)
		 * @param	ground		地形MC
		 */
		public function MyShip(stageMC:MovieClip, ground:MovieClip)
		{
			keyMgr = new KeyMgr(stageMC);
		
			this.ground = ground;
		}
		
		/**
		 * フレーム関数
		 */
		public function frameFunc()
		{
			setVector();
			move();			
		}
		
		/**
		 * 移動ベクトルを設定
		 */
		function setVector()
		{
			vx = vy = 0;
			
			if (keyMgr.isDown(Keyboard.RIGHT)) {
				vx = moveSpd;
			}
			if (keyMgr.isDown(Keyboard.LEFT)) {
				vx = -moveSpd;
			}
			if (keyMgr.isDown(Keyboard.DOWN)) {
				vy = moveSpd;				
			}
			if (keyMgr.isDown(Keyboard.UP)) {
				vy = -moveSpd;
			}
		}
		
		/*+
		 * 移動
		 */
		function move():void
		{
			var lastX:Number = this.x;
			var lastY:Number = this.y;
			
			//Ｘ座標を移動 地形に当たってたら全快の座標に戻す
			this.x += vx;
			if (ground.hitTestPoint(this.x, this.y, true)) {
				this.x = lastX;
			}
			else {
				lastX = this.x;
			}
						
			
			//Ｙ座標を移動
			this.y += vy;
			if (ground.hitTestPoint(this.x, this.y, true)) {
				this.y = lastY;
			}
		}
		
	}
}